/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.arrebol.apc.model.admin;

import com.arrebol.apc.model.enums.ActiveStatus;
import com.arrebol.apc.model.enums.LoanStatus;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.hibernate.annotations.GenericGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@Table(name = "APC_LOAN_EMPLOYEE")
public class LoanEmployee implements Serializable {
    private static final long serialVersionUID = 2775085143559471537L;
    
    @Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
    @Column(name = "id", length = 36)
    private String id;
    
    @Column(name = "id_employee", length = 36)
    private String idEmployee;
    
    @Column(name = "amount_loan", nullable = false)
    private BigDecimal amountLoan;
    
    @Column(name = "balance", nullable = false)
    private BigDecimal balance;
    
    @Column(name = "amount_to_pay", nullable = false)
    private BigDecimal amountToPay;
    
    @Column(name = "total_amount_to_pay", nullable = false)
    private BigDecimal totalAmountToPay;
    
    @Enumerated(EnumType.STRING)
    @Column(name = "loan_employee_status", nullable = false)
    private ActiveStatus loanEmployeeStatus;
    
    @Column(name = "created_by", length = 36)
    private String createdBy;
    
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "created_on", length = 19)
    private Date createdOn;
    
        @Column(name = "last_updated_by", length = 36)
    private String lastUpdatedBy;
    
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "last_updated_on", length = 19)
    private Date lastUpdatedOn;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getIdEmployee() {
        return idEmployee;
    }

    public void setIdEmployee(String idEmployee) {
        this.idEmployee = idEmployee;
    }

    public BigDecimal getAmountLoan() {
        return amountLoan;
    }

    public void setAmountLoan(BigDecimal amountLoan) {
        this.amountLoan = amountLoan;
    }

    public BigDecimal getBalance() {
        return balance;
    }

    public void setBalance(BigDecimal balance) {
        this.balance = balance;
    }
    
    public BigDecimal getAmountToPay() {
        return amountToPay;
    }

    public void setAmountToPay(BigDecimal amountToPay) {
        this.amountToPay = amountToPay;
    }

    public ActiveStatus getLoanEmployeeStatus() {
        return loanEmployeeStatus;
    }

    public void setLoanEmployeeStatus(ActiveStatus loanEmployeeStatus) {
        this.loanEmployeeStatus = loanEmployeeStatus;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    public String getLastUpdatedBy() {
        return lastUpdatedBy;
    }

    public void setLastUpdatedBy(String lastUpdatedBy) {
        this.lastUpdatedBy = lastUpdatedBy;
    }

    public Date getLastUpdatedOn() {
        return lastUpdatedOn;
    }

    public void setLastUpdatedOn(Date lastUpdatedOn) {
        this.lastUpdatedOn = lastUpdatedOn;
    }
    
    public BigDecimal getTotalAmountToPay() {
        return totalAmountToPay;
    }

    public void setTotalAmountToPay(BigDecimal totalAmountToPay) {
        this.totalAmountToPay = totalAmountToPay;
    }
}
