/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.arrebol.apc.model.views;

import com.arrebol.apc.model.enums.EmployeeSavingType;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import org.hibernate.annotations.GenericGenerator;

/**
 *
 * @author David Rodriguez
 */
@Entity
@Table(name = "APC_STATS_EMPLOYEE_SAVING_VIEW")
public class StatsEmployeeSavingView implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
    @Column(name = "id", length = 36)
    private String id;

    @Column(name = "id_user", length = 36)
    private String idUser;

    @Column(name = "name")
    private String userName;

    @Column(name = "employee_saving")
    private BigDecimal employeeSaving;

    @Column(name = "created_on")
    private Date createdOn;
    
    @Column(name = "route_name")
    private String routeName;

    public String getId() {
        return id;
    }

    @Enumerated(EnumType.STRING)
    @Column(name = "type")
    private EmployeeSavingType type;

    public String getTypeText() {
        if(getType().equals(EmployeeSavingType.DISPOSAL))
            return "Disposición de ahorro";
        else if(getType().equals(EmployeeSavingType.CANCEL)){
            return "Ahorro Cancelado";}
        else{
            return "Ahorro";
        }
    }
    
    public EmployeeSavingType getType() {
        return type;
    }

    public void setType(EmployeeSavingType type) {
        this.type = type;
    }
    
    public void setId(String id) {
        this.id = id;
    }

    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    public String getIdUser() {
        return idUser;
    }

    public void setIdUser(String idUser) {
        this.idUser = idUser;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public BigDecimal getEmployeeSaving() {
        return employeeSaving;
    }

    public void setEmployeeSaving(BigDecimal employeeSaving) {
        this.employeeSaving = employeeSaving;
    }

    public String getRouteName() {
        return routeName;
    }

    public void setRouteName(String routeName) {
        this.routeName = routeName;
    }
    
    @Override
    public String toString() {
        return "EmployeeSaving{" + "idUser=" + idUser + ", userName=" + userName + ", employeeSaving=" + employeeSaving + ", createdOn=" + createdOn + '}';
    }
}
